searchNodes=[{"doc":"Reactor is a dynamic, concurrent, dependency resolving saga orchestrator. Usage You can construct a reactor using the Reactor Spark DSL: defmodule HelloWorldReactor do @moduledoc false use Reactor input :whom step :greet , Greeter do argument :whom , input ( :whom ) end return :greet end iex&gt; Reactor . run ( HelloWorldReactor , %{ whom : &quot;Dear Reader&quot; } ) { :ok , &quot;Hello, Dear Reader!&quot; } or you can build it programmatically: iex&gt; reactor = Builder . new ( ) ...&gt; { :ok , reactor } = Builder . add_input ( reactor , :whom ) ...&gt; { :ok , reactor } = Builder . add_step ( reactor , :greet , Greeter , whom : { :input , :whom } ) ...&gt; { :ok , reactor } = Builder . return ( reactor , :greet ) ...&gt; Reactor . run ( reactor , %{ whom : nil } ) { :ok , &quot;Hello, World!&quot; }","ref":"Reactor.html","title":"Reactor","type":"module"},{"doc":"","ref":"Reactor.html#default_extension_kinds/0","title":"Reactor.default_extension_kinds/0","type":"function"},{"doc":"","ref":"Reactor.html#default_extensions/0","title":"Reactor.default_extensions/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.explain/2 .","ref":"Reactor.html#explain/2","title":"Reactor.explain/2","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_before_compile/1 .","ref":"Reactor.html#handle_before_compile/1","title":"Reactor.handle_before_compile/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_opts/1 .","ref":"Reactor.html#handle_opts/1","title":"Reactor.handle_opts/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.init/1 .","ref":"Reactor.html#init/1","title":"Reactor.init/1","type":"function"},{"doc":"","ref":"Reactor.html#many_extension_kinds/0","title":"Reactor.many_extension_kinds/0","type":"function"},{"doc":"Run a reactor.","ref":"Reactor.html#run/4","title":"Reactor.run/4","type":"function"},{"doc":"","ref":"Reactor.html#single_extension_kinds/0","title":"Reactor.single_extension_kinds/0","type":"function"},{"doc":"","ref":"Reactor.html#t:context/0","title":"Reactor.context/0","type":"type"},{"doc":"","ref":"Reactor.html#t:inputs/0","title":"Reactor.inputs/0","type":"type"},{"doc":"","ref":"Reactor.html#t:options/0","title":"Reactor.options/0","type":"type"},{"doc":"","ref":"Reactor.html#t:state/0","title":"Reactor.state/0","type":"type"},{"doc":"","ref":"Reactor.html#t:t/0","title":"Reactor.t/0","type":"type"},{"doc":"A step argument.","ref":"Reactor.Argument.html","title":"Reactor.Argument","type":"module"},{"doc":"Build an argument which refers to a reactor input with an optional transformation applied. Example iex&gt; Argument . from_input ( :argument_name , :input_name , &amp; String . to_integer / 1 )","ref":"Reactor.Argument.html#from_input/3","title":"Reactor.Argument.from_input/3","type":"function"},{"doc":"Build an argument which refers to the result of another step with an optional transformation applied. Example iex&gt; Argument . from_input ( :argument_name , :step_name , &amp; Atom . to_string / 1 )","ref":"Reactor.Argument.html#from_result/3","title":"Reactor.Argument.from_result/3","type":"function"},{"doc":"Validate that the argument has a transform.","ref":"Reactor.Argument.html#has_transform/1","title":"Reactor.Argument.has_transform/1","type":"macro"},{"doc":"Validate that the argument is an Argument struct.","ref":"Reactor.Argument.html#is_argument/1","title":"Reactor.Argument.is_argument/1","type":"macro"},{"doc":"Validate that the argument refers to a reactor input.","ref":"Reactor.Argument.html#is_from_input/1","title":"Reactor.Argument.is_from_input/1","type":"macro"},{"doc":"Validate that the argument refers to a step result.","ref":"Reactor.Argument.html#is_from_result/1","title":"Reactor.Argument.is_from_result/1","type":"macro"},{"doc":"","ref":"Reactor.Argument.html#t:t/0","title":"Reactor.Argument.t/0","type":"type"},{"doc":"Template functions used to declare DSL arguments.","ref":"Reactor.Argument.Templates.html","title":"Reactor.Argument.Templates","type":"module"},{"doc":"The input template helper for the Reactor DSL. Example defmodule ExampleReactor do use Reactor input :name step :greet do # here: --------↓↓↓↓↓ argument :name , input ( :name ) impl fn %{ name : nil } , _ , _ -&gt; { :ok , &quot;Hello, World!&quot; } %{ name : name } , _ , _ -&gt; { :ok , &quot;Hello, \#{ name } !&quot; } end end end","ref":"Reactor.Argument.Templates.html#input/1","title":"Reactor.Argument.Templates.input/1","type":"function"},{"doc":"The result template helper for the Reactor DSL. Example defmodule ExampleReactor do use Reactor step :whom do impl fn -&gt; { :ok , Enum . random ( [ &quot;Marty&quot; , &quot;Doc&quot; , &quot;Jennifer&quot; , &quot;Lorraine&quot; , &quot;George&quot; , nil ] ) } end end step :greet do # here: --------↓↓↓↓↓↓ argument :name , result ( :whom ) impl fn %{ name : nil } , _ , _ -&gt; { :ok , &quot;Hello, World!&quot; } %{ name : name } , _ , _ -&gt; { :ok , &quot;Hello, \#{ name } !&quot; } end end end","ref":"Reactor.Argument.Templates.html#result/1","title":"Reactor.Argument.Templates.result/1","type":"function"},{"doc":"Build a new Reactor programmatically. You don't have to use the Reactor DSL to create a Reactor. The functions in this module allow you to define a Reactor programmatically. This is especially useful if you need to create a reactor dynamically (maybe based on a UI such as React Flow ). Example reactor = Builder . new ( ) { :ok , reactor } = Builder . add_input ( reactor , :name ) argument = Argument . from_input ( :name ) { :ok , reactor } = Builder . add_step ( reactor , :greet , [ argument ] ) { :ok , reactor } = Builder . return ( reactor , :greet )","ref":"Reactor.Builder.html","title":"Reactor.Builder","type":"module"},{"doc":"Add a named input to the Reactor. This both places the input in the Reactor for later input validation and adds steps to the Reactor which will emit and (possibly) transform the input.","ref":"Reactor.Builder.html#add_input/3","title":"Reactor.Builder.add_input/3","type":"function"},{"doc":"Add a step to the Reactor. Add a new step to the Reactor. Rewrites input arguments to use the result of the input steps and injects transformation steps as required.","ref":"Reactor.Builder.html#add_step/5","title":"Reactor.Builder.add_step/5","type":"function"},{"doc":"Build a new, empty Reactor.","ref":"Reactor.Builder.html#new/0","title":"Reactor.Builder.new/0","type":"function"},{"doc":"Build a step which can be added to a reactor at runtime. Note that the built step doesn't support argument transformations - you should add an additional step to do the transformation needed (this is what add_step/5 does anyway).","ref":"Reactor.Builder.html#new_step/4","title":"Reactor.Builder.new_step/4","type":"function"},{"doc":"Specify the return value of the Reactor. The return value must be the result of a completed step.","ref":"Reactor.Builder.html#return/2","title":"Reactor.Builder.return/2","type":"function"},{"doc":"Should the step be run asynchronously?","ref":"Reactor.Builder.html#t:async?/0","title":"Reactor.Builder.async?/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:impl/0","title":"Reactor.Builder.impl/0","type":"type"},{"doc":"How many times is the step allowed to retry?","ref":"Reactor.Builder.html#t:max_retries/0","title":"Reactor.Builder.max_retries/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:step_argument/0","title":"Reactor.Builder.step_argument/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:step_options/0","title":"Reactor.Builder.step_options/0","type":"type"},{"doc":"The Reactor executor. The executor handles the main loop of running a Reactor. The algorithm is somewhat confusing, so here it is in pseudocode: Find any async tasks (from a previous loop) which are completed. Either recurse or continue if none are found. Find any async steps in the plan which are ready to run (they have no in-edges in the graph) and start as many as possible (given the constraints of max_concurrency ). Either start over, or continue if none are found. Find a single synchronous step which is ready to run and execute it. If there was one then recurse, otherwise continue. Check if there are no more steps left in the plan (there are zero vertices). If so, collect the return value and exit, otherwise recurse. Whenever a step is run, whether run synchronously or asynchronously, the following happens: When the step is successful: a. If the step is undoable (ie Step.can?(module, :undo)? returns true ) then the step and the result are stored in the Reactor's undo stack. b. If the result is depended upon by another step (the graph has out-edges for the step) or the step is asking the reactor to halt then the result is stored in the Reactor's intermediate results. c. The step is removed from the graph (along with it's out-edges, freeing up it's dependents to run). When the step is unsuccessful (returns an error tuple or raises): a. If the step can be compensated then compensation is attempted up to five times before giving up. b. The reactor iterates it's undo stack calling undo on each step. When a step or compensation asks for a retry then the step is placed back in the graph to be run again next iteration.","ref":"Reactor.Executor.html","title":"Reactor.Executor","type":"module"},{"doc":"Run a reactor. Provided a Reactor which has been planned and the correct inputs, then run the Reactor until completion, halting or failure. You probably shouldn't call this directly, but use Reactor.run/4 instead.","ref":"Reactor.Executor.html#run/4","title":"Reactor.Executor.run/4","type":"function"},{"doc":"Handle the asynchronous execution of a batch of steps, along with any mutations to the reactor or execution state.","ref":"Reactor.Executor.Async.html","title":"Reactor.Executor.Async","type":"module"},{"doc":"When the Reactor needs to shut down for any reason, we need to await all the currently running asynchronous steps and delete any task vertices.","ref":"Reactor.Executor.Async.html#collect_remaining_tasks_for_shutdown/2","title":"Reactor.Executor.Async.collect_remaining_tasks_for_shutdown/2","type":"function"},{"doc":"Check to see if any steps are completed, and if so handle them.","ref":"Reactor.Executor.Async.html#handle_completed_steps/2","title":"Reactor.Executor.Async.handle_completed_steps/2","type":"function"},{"doc":"Start as many of the provided steps as possible. Takes into account he maximum concurrency and available work slots.","ref":"Reactor.Executor.Async.html#start_steps/4","title":"Reactor.Executor.Async.start_steps/4","type":"function"},{"doc":"Handle argument checking and state setup for a Reactor run.","ref":"Reactor.Executor.Init.html","title":"Reactor.Executor.Init","type":"module"},{"doc":"Contains the reactor execution state. This is run-time only information.","ref":"Reactor.Executor.State.html","title":"Reactor.Executor.State","type":"module"},{"doc":"","ref":"Reactor.Executor.State.html#t:t/0","title":"Reactor.Executor.State.t/0","type":"type"},{"doc":"Run an individual step, including compensation if possible.","ref":"Reactor.Executor.StepRunner.html","title":"Reactor.Executor.StepRunner","type":"module"},{"doc":"Collect the arguments and and run a step, with compensation if required.","ref":"Reactor.Executor.StepRunner.html#run/2","title":"Reactor.Executor.StepRunner.run/2","type":"function"},{"doc":"Undo a step if possible.","ref":"Reactor.Executor.StepRunner.html#undo/3","title":"Reactor.Executor.StepRunner.undo/3","type":"function"},{"doc":"Handle the synchronous execution of a single step, along with any mutations to the reactor or execution state.","ref":"Reactor.Executor.Sync.html","title":"Reactor.Executor.Sync","type":"module"},{"doc":"Try and run a step synchronously.","ref":"Reactor.Executor.Sync.html#run/3","title":"Reactor.Executor.Sync.run/3","type":"function"},{"doc":"Introspection for the Reactor DSL.","ref":"Reactor.Info.html","title":"Reactor.Info","type":"module"},{"doc":"reactor DSL entities","ref":"Reactor.Info.html#reactor/1","title":"Reactor.Info.reactor/1","type":"function"},{"doc":"reactor DSL options Returns a map containing the and any configured or default values.","ref":"Reactor.Info.html#reactor_options/1","title":"Reactor.Info.reactor_options/1","type":"function"},{"doc":"Convert a reactor DSL module into a reactor struct.","ref":"Reactor.Info.html#to_struct/1","title":"Reactor.Info.to_struct/1","type":"function"},{"doc":"The struct used to store input DSL entities.","ref":"Reactor.Input.html","title":"Reactor.Input","type":"module"},{"doc":"","ref":"Reactor.Input.html#t:t/0","title":"Reactor.Input.t/0","type":"type"},{"doc":"Build an execution plan for a Reactor. Converts any unplanned steps into vertices in a graph with directed edges between them representing their dependencies (arguments).","ref":"Reactor.Planner.html","title":"Reactor.Planner","type":"module"},{"doc":"Build an execution plan for a Reactor. Builds a graph of the step dependencies, resolves them and then builds an execution plan.","ref":"Reactor.Planner.html#plan/1","title":"Reactor.Planner.plan/1","type":"function"},{"doc":"The struct used to store steps.","ref":"Reactor.Step.html","title":"Reactor.Step","type":"behaviour"},{"doc":"Find out of a step has a capability.","ref":"Reactor.Step.html#can?/2","title":"Reactor.Step.can?/2","type":"function"},{"doc":"Compensate a step","ref":"Reactor.Step.html#compensate/4","title":"Reactor.Step.compensate/4","type":"function"},{"doc":"Compensate for the failure of the step. Do not implement this callback if your step doesn't support compensation. If run/3 returned an error then this callback will be called the error reason and the original arguments. This provides you the opportunity to handle the error in a number of ways and direct the reactor as to what to do next. This callback is only called if c:can?/1 returns true for the :compensate capability. Arguments reason - the error reason returned from run/3 . arguments - the arguments passed to the step. context - the reactor context. options - a keyword list of options provided to the step (if any). Return values {:continue, value} if you're able to provide a valid result for the step (perhaps by re-running the original computation) then return that within a :continue tuple and execution will continue as planned. :ok the step was successfully compensated and the reactor should continue undoing upstream changes. :retry if you would like the reactor to attempt to re-run the step.","ref":"Reactor.Step.html#c:compensate/4","title":"Reactor.Step.compensate/4","type":"callback"},{"doc":"Execute a step.","ref":"Reactor.Step.html#run/3","title":"Reactor.Step.run/3","type":"function"},{"doc":"Execute the step. This is the function that implements the behaviour you wish to execute. You will receive arguments as per the t:Step.t definition along with their corresponding values as a map and a copy of the current reactor context. Arguments arguments - A map of arguments as per the t:Step.t definition we're called from. context - The reactor context. options - A keyword list of options provided to the step (if any). Return values {:ok, value} the step completed successfully it returns the value in an ok tuple. {:ok, value, [step]} the step completed successfully and wants to add new steps to the reactor. {:error, reason} the if step failed, return an error tuple. {:halt, reason} terminate (or pause) reactor execution. If there are actively running steps the reactor will wait for them to finish and then return the incomplete state for later resumption.","ref":"Reactor.Step.html#c:run/3","title":"Reactor.Step.run/3","type":"callback"},{"doc":"Undo a step","ref":"Reactor.Step.html#undo/4","title":"Reactor.Step.undo/4","type":"function"},{"doc":"Undo a previously successful execution of the step. Do not implement this callback if your step doesn't support undoing. This callback is called when the reactor encounters an unhandled error later in it's execution run and must undo the work previously done. This callback is only called if c:can?/1 returns true for the :undo capability. Arguments value - the return value of the previously successful call to run/3 . arguments - the arguments passed to the step. context - the reactor context. options - a keyword list of options provided to the step (if any). Return values :ok the step was successfully undo and the reactor should continue rolling back. {:error, reason} there was an error while attempting to compensate. The reactor will collect the error and continue rolling back. :retry if you would like the reactor to attempt to undo the again later possibly in the case of a network failure for example.","ref":"Reactor.Step.html#c:undo/4","title":"Reactor.Step.undo/4","type":"callback"},{"doc":"Optional capabilities which may be implemented by the step module. This allows us to optimise out calls steps which cannot be undone, etc.","ref":"Reactor.Step.html#t:capability/0","title":"Reactor.Step.capability/0","type":"type"},{"doc":"Possible valid return values for the compensate/4 callback.","ref":"Reactor.Step.html#t:compensate_result/0","title":"Reactor.Step.compensate_result/0","type":"type"},{"doc":"Possible valid return values for the run/3 callback.","ref":"Reactor.Step.html#t:run_result/0","title":"Reactor.Step.run_result/0","type":"type"},{"doc":"","ref":"Reactor.Step.html#t:t/0","title":"Reactor.Step.t/0","type":"type"},{"doc":"Possible valid return values for the undo/4 callback.","ref":"Reactor.Step.html#t:undo_result/0","title":"Reactor.Step.undo_result/0","type":"type"},{"doc":"The built-in step for executing in-line DSL anonymous functions. This step assumes that it is being called as per the :spark_function_behaviour semantics.","ref":"Reactor.Step.AnonFn.html","title":"Reactor.Step.AnonFn","type":"module"},{"doc":"A built-in step which emits a reactor input.","ref":"Reactor.Step.Input.html","title":"Reactor.Step.Input","type":"module"},{"doc":"The built-in step for executing input and argument transformations. This step assumes that it is being executed as per :spark_function_behaviour semantics.","ref":"Reactor.Step.Transform.html","title":"Reactor.Step.Transform","type":"module"},{"doc":"The input template.","ref":"Reactor.Template.Input.html","title":"Reactor.Template.Input","type":"module"},{"doc":"","ref":"Reactor.Template.Input.html#t:t/0","title":"Reactor.Template.Input.t/0","type":"type"},{"doc":"The result template.","ref":"Reactor.Template.Result.html","title":"Reactor.Template.Result","type":"module"},{"doc":"","ref":"Reactor.Template.Result.html#t:t/0","title":"Reactor.Template.Result.t/0","type":"type"},{"doc":"Reactor is a dynamic, concurrent, dependency resolving saga orchestrator. Woah. That's a lot. Let's break it down: Saga orchestrator A [saga][saga pattern] is a way of providing transaction-like semantics across multiple distinct resources. Dependency resolving reactor allows you to describe the dependencies between your saga steps using arguments which are converted into a DAG and used to compute execution order. Concurrent unless otherwise specified reactor will run as many steps as possible concurrently whilst taking into account the results of the dependency resolution. Dynamic whilst you can define a reactor statically using our awesome DSL, you can also build workflows dynamically - and even add steps while the reactor is running. saga pattern","ref":"readme.html","title":"Read Me","type":"extras"},{"doc":"The package can be installed by adding reactor to your list of dependencies in mix.exs : def deps do [ { :reactor , &quot;~&gt; 0.2.1&quot; } ] end","ref":"readme.html#installation","title":"Read Me - Installation","type":"extras"},{"doc":"Documentation for the latest release will be available on hexdocs and for the main branch .","ref":"readme.html#documentation","title":"Read Me - Documentation","type":"extras"},{"doc":"To contribute updates, fixes or new features please fork and open a pull-request against main . Please use conventional commits - this allows us to dynamically generate the changelog. Feel free to ask any questions on the #reactor channel on the Ash Discord .","ref":"readme.html#contributing","title":"Read Me - Contributing","type":"extras"},{"doc":"reactor is licensed under the terms of the MIT license . See the LICENSE file in this repository for details. saga pattern","ref":"readme.html#licence","title":"Read Me - Licence","type":"extras"},{"doc":"Reactor is a lot of things: A saga orchestrator . A composable DSL for creating workflows. A builder for dynamically creating workflows. Capable of mixing concurrent and serialised workflows. Resolves dependencies between tasks using a directed acyclic graph . Let's start by breaking down what each of these features are, and how we can use them.","ref":"getting-started-with-reactor.html","title":"Getting started with Reactor","type":"extras"},{"doc":"If you've been building apps long enough you will have used database transactions. They're amazing. Basically, if you put all your changes in a transaction and there's a failure then the transaction gets rolled back and the system is not left in an inconsistent state. This is great when you're working with a single database, but in the modern world we often have to integrate with many different kinds of data stores and as many different SaaS products . Often we need to orchestrate a &quot;transaction&quot; across multiple services at once; for example: Register a new user Create a Stripe customer Create a Stripe subscription Send a transactional welcome email via SendGrid Track the conversion in Salesforce If any of these steps fails we may want to retry or roll back depending on what failed and whether it's recoverable. Reactor allows us to do this by defining the Reactor.Step behaviour: defmodule MyApp.CreateStripeSubscriptionStep do use Reactor.Step @impl true def run ( arguments , context , options ) do Stripe.Subscription . create ( arguments . stripe_customer_id , items : [ plan : arguments . stripe_plan_id ] ) end @impl true def compensate ( %{ code : :network_error } , arguments , context , options ) do :retry end def compensate ( error , arguments , context , options ) do :ok end @impl true def undo ( subscription , arguments , context , options ) do case Stripe.Subscription . delete ( subscription ) do { :ok , _ } -&gt; :ok { :error , reason } -&gt; { :error , reason } end end end Here we've defined a step that tries to create a new Stripe subscription. If that fails then we have defined compensate/4 check whether it was a network error, and if so ask the Reactor to retry, otherwise we return :ok because the subscription wasn't created so we don't have to do any other clean up. Lastly, we define undo/4 to delete the subscription if the Reactor asks us to undo our work - which it will do if a step later in the workflow fails. How do you compose these steps together you ask? Let's discuss that in the next section.","ref":"getting-started-with-reactor.html#transaction-like-semantics-with-sagas","title":"Getting started with Reactor - Transaction-like semantics with Sagas","type":"extras"},{"doc":"Reactor uses spark to define an easy to use (and easy to extend) DSL for defining workflows. Let's start with an example: defmodule MyApp.RegisterUserReactor do use Reactor input :email input :password input :plan_name step :register_user , MyApp.RegisterUserStep do argument :email , input ( :email ) argument :password , input ( :password ) end step :create_stripe_customer , MyApp.CreateStripeCustomerStep do argument :email , input ( :email ) end step :find_stripe_plan , MyApp.FindStripePlanStep do argument :plan_name , input ( :plan_name ) end step :create_stripe_subscription , MyApp.CreateStripeSubscriptionStep do argument :customer_id do source result ( :create_stripe_customer ) transform &amp; ( &amp;1 . id ) end argument :plan_id do source result ( :get_stripe_plan ) transform &amp; ( &amp;1 . id ) end end step :send_welcome_email , MyApp.SendWelcomeEmailStep do argument :email , input ( :email ) argument :_subscription , result ( :create_stripe_subscription ) end step :track_conversion , MyApp.TrackSalesforceConversionStep do argument :email , input ( :email ) argument :plan_name , input ( :plan_name ) argument :_welcome_email , result ( :send_welcome_email ) end return :register_user end Here we've defined a Reactor that performs the steps needed for the user registration example above. Here we define the steps that need to be performed and describe the dependencies between them by way of arguments. Beware of ordering Whilst the order of the steps in the example makes sense logically it has no effect on the order that the Reactor will execute them in. This is the fundamental difference between Reactor and other Saga tools in the Elixir ecosystem. The Reactor will put the steps into a graph with the steps as vertices and the arguments as edges and will find any that have no inbound edges and run as many of them at once as possible. This means that :register_user , :create_stripe_customer and :find_stripe_plan will all execute simultaneously, after which :create_stripe_subscription , then :send_welcome_email and :track_conversion will run. Notice that :send_welcome_email and :track_conversion have arguments that depend on the results of previews steps that they don't necessarily need, however we want to ensure that they don't run until all the important steps are complete (it's hard to unsend an email!)","ref":"getting-started-with-reactor.html#composing-steps-with-the-reactor-dsl","title":"Getting started with Reactor - Composing steps with the Reactor DSL","type":"extras"},{"doc":"While using the DSL makes it extremely easy to build a static workflow, sometimes you need the flexibility to build a workflow based on a set of criteria that may not be known at compile time (for example if you're using user input to build the workflow). Every Reactor is ultimately an instance of the Reactor struct (you can use Reactor.Info.to_struct(MyApp.RegisterUserReactor) to see the one for the DSL Reactor above). The functions in Reactor.Builder can be used to create an identical workflow: iex&gt; reactor = Reactor.Builder . new ( ) ...&gt; { :ok , reactor } = Reactor.Builder . add_input ( reactor , :email ) ...&gt; { :ok , reactor } = Reactor.Builder . add_input ( reactor , :password ) ...&gt; { :ok , reactor } = Reactor.Builder . add_input ( reactor , :plan_name ) ...&gt; { :ok , reactor } = Reactor.Builder . add_step ( reactor , :register_user , MyApp.RegisterUserStep , email : { :input , :email } , password : { :input , :password } ) # etc...","ref":"getting-started-with-reactor.html#building-workflows-programmatically","title":"Getting started with Reactor - Building workflows programmatically","type":"extras"},{"doc":"If you look at the Reactor.Step struct, you'll see that it has an async? field. This is available as a step DSL option, and as an option to add_step/5 . It defaults to true , however if you set it to false Reactor will run the step synchronously. Note that it will only run synchronous steps when it has run out of async steps which can be started. Other than that caveat, Reactor will follow the same ordering rules as specified above.","ref":"getting-started-with-reactor.html#mixing-concurrent-and-synchronous-workflow-steps","title":"Getting started with Reactor - Mixing concurrent and synchronous workflow steps","type":"extras"},{"doc":"You can pass either a Reactor DSL module or a Reactor struct straight into the Reactor.run/1..4 function.","ref":"getting-started-with-reactor.html#running-your-reactor","title":"Getting started with Reactor - Running your Reactor","type":"extras"},{"doc":"Any step in the flow can return {:halt, value} instead of {:ok, value} . When this happens Reactor will wait for any running asynchronous steps to finish and then halt the Reactor returning {:halted, reactor} . Later on you can resume the Reactor by passing the halted reactor to the Reactor.run/1..4 function.","ref":"getting-started-with-reactor.html#halting-and-resuming-workflows","title":"Getting started with Reactor - Halting and resuming workflows","type":"extras"},{"doc":"Any step can return {:ok, value, additional_steps} instead of just {:ok, value} and those new steps will be added to the graph and have their dependencies calculated automatically. additional_steps should be a list of Reactor.Step structs, which you can create with Reactor.Builder.new_step/2..4 . There are a couple of additional things to be aware of when steps at run time: If you add steps that induce a cyclic dependency then the Reactor will commence an undo, just as if a step had failed. Steps can have the same name as other steps and their intermediate results will be replaced. You are allowed to make dependency cycles in the very specific case of a new step relying on it's own output.","ref":"getting-started-with-reactor.html#dynamically-adding-steps-at-reactor-run-time","title":"Getting started with Reactor - Dynamically adding steps at Reactor run time","type":"extras"}]